HDU 1052 Tian Ji -- The Horse Racing(贪心)

Tian Ji -- The Horse Racing

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 14907    Accepted Submission(s): 4286


Problem Description
Here is a famous story in Chinese history.

"That was about 2300 years ago. General Tian Ji was a high official in the country Qi. He likes to play horse racing with the king and others."

"Both of Tian and the king have three horses in different classes, namely, regular, plus, and super. The rule is to have three rounds in a match; each of the horses must be used in one round. The winner of a single round takes two hundred silver dollars from the loser."

"Being the most powerful man in the country, the king has so nice horses that in each class his horse is better than Tian's. As a result, each time the king takes six hundred silver dollars from Tian."

"Tian Ji was not happy about that, until he met Sun Bin, one of the most famous generals in Chinese history. Using a little trick due to Sun, Tian Ji brought home two hundred silver dollars and such a grace in the next match."

"It was a rather simple trick. Using his regular class horse race against the super class from the king, they will certainly lose that round. But then his plus beat the king's regular, and his super beat the king's plus. What a simple trick. And how do you think of Tian Ji, the high ranked official in China?"

HDU 1052 Tian Ji -- The Horse Racing(贪心)_第1张图片

Were Tian Ji lives in nowadays, he will certainly laugh at himself. Even more, were he sitting in the ACM contest right now, he may discover that the horse racing problem can be simply viewed as finding the maximum matching in a bipartite graph. Draw Tian's horses on one side, and the king's horses on the other. Whenever one of Tian's horses can beat one from the king, we draw an edge between them, meaning we wish to establish this pair. Then, the problem of winning as many rounds as possible is just to find the maximum matching in this graph. If there are ties, the problem becomes more complicated, he needs to assign weights 0, 1, or -1 to all the possible edges, and find a maximum weighted perfect matching...

However, the horse racing problem is a very special case of bipartite matching. The graph is decided by the speed of the horses --- a vertex of higher speed always beat a vertex of lower speed. In this case, the weighted bipartite matching algorithm is a too advanced tool to deal with the problem.

In this problem, you are asked to write a program to solve this special case of matching problem.
 

Input
The input consists of up to 50 test cases. Each case starts with a positive integer n (n <= 1000) on the first line, which is the number of horses on each side. The next n integers on the second line are the speeds of Tian’s horses. Then the next n integers on the third line are the speeds of the king’s horses. The input ends with a line that has a single 0 after the last test case.
 

Output
For each input case, output a line containing a single number, which is the maximum money Tian Ji will get, in silver dollars.
 

Sample Input
   
   
   
   
3 92 83 71 95 87 74 2 20 20 20 20 2 20 19 22 18 0
 

Sample Output
   
   
   
   
200 0 0
 


                   题目大意:题目意思很好懂,田忌赛马都懂哈,先给你田忌的n匹马,给你齐王的n匹马。问你最多能得多少分,胜一场200分负一场-200分,平一场不得分。

            解题思路: 自己开始贪心的策略是先用田忌的快马与齐王的快马相比,>则胜一场,<则用田忌的慢马与齐王的快马相比。=的话这里没处理好,所以就WA了。看了下大牛的博客。讲下思路。

思路是每次先让慢马相比,如果>胜一场,<则拉下水,=要看自己的快马能不能赢,不能赢,则拉下水,能赢则赢一场。
下面文字来源于nyist_xiaod

1.若田忌最慢的马可以战胜齐王最慢的马,那么就让它战胜那匹慢马,胜利场次加1。(田忌最慢马 > 齐王最慢马)

2.若田忌最慢的马不能战胜齐王最慢的马,那么它更加不能战胜其他的马,那就让它输,而且输给齐王最快马,失败场次加1。(田忌最慢马 < 齐王最快马)

3.若田忌最慢的马与齐王最慢的马速度相等。此时,不能简单地认为与它打成平手就是最好情况,相反,打平是下下策,为什么呢?

因为自己后面的队友很有可能战胜此时对方的这匹慢马,所以就算自己输一场,队友也能帮忙赢回一场,而胜一场,输一场的收益和打平一场的收益是一样的,而且自己输的时候可以拉对方最快的马下水,给己方最快的马创造更大的胜利机会(因为它失去了一个强劲的对手),也就是说己方最快的马很可能因为自己的牺牲再胜利一场,从这个角度看,还是自己故意输掉比较好。


但是,还有一点需要注意,当自己放水前,如果己方最快的马原本就比对方最快的马快,然后还输给对方最快的马,那么己方最快的马的才华就浪费了,为什么?

很简单,它原本就能赢,需要你放水么?- -!换句话说,这种情况下,自己的牺牲没有一点价值。

所以,在放水时,一定要保证己方最快马不快于对方最快马。满足此条件后,让己方最慢马与对方最快马去比赛(有可能平局),这样,田忌的马就得到了充分的利用。


AC代码:
#include<iostream>
#include<cstring>
#include<algorithm>
#include<cstdio>
using namespace std;

int a[1005];
int b[1005];
int cmp(int a,int b)
{
    if(a>b) return 1;
    return 0;
}

int main()
{
    int n,i,j,sum,len1,len2;
    while(scanf("%d",&n)&&n)
    {
        for(i=0;i<n;i++)
            scanf("%d",&a[i]);
        sort(a,a+n,cmp); //田忌的马从快到慢排序
        for(i=0;i<n;i++)
            scanf("%d",&b[i]);
        sort(b,b+n,cmp); //齐王的马从快到慢排序
        i=0,j=0;
        len1=len2=n-1;  //最慢的马的位置
        sum=0;
        while(i<=len1&&j<=len2)
        {
            if(a[len1]>b[len2]) //田忌慢马>齐王慢马
            {
                sum++;  //先胜一场
                len1--,len2--;
            }
            else if(a[len1]<b[len2])
            {
                 sum--;    //拿最慢的马与齐王快马赛
                 j++;
                 len1--;
            }
            else
            {
                if(i<len1) //除去最快的马还有别的马
                {
                    if(a[i]<=b[j])  //田忌的快马赢不了
                    {
                        if(a[len1]<b[j])
                            sum--;
                        len1--,j++;
                    }
                    else
                    {
                        sum++;  //快马赢
                        i++; j++;
                    }
                }
                else
                {
                    len1--,len2--; //平局
                }
            }
        }

        printf("%d\n",sum*200);
    }
    return 0;
}

/*
4
70 65 50 20
70 65 55 20
4
70 60 50 20
70 65 55 20
4
70 55 50 20
70 65 55 20
*/

//15MS 236K


推荐一首很好听的歌:
爱一点来自莫艳琳

你可能感兴趣的:(贪心)